SystemOrganization addCategory: #MyCounter!

TestCase subclass: #CounterTest
	instanceVariableNames: 'count'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MyCounter'!

!CounterTest commentStamp: '<historical>' prior: 0!
Test!

!CounterTest methodsFor: 'tests' stamp: 'AllexOliveira 5/2/2018 19:06'!
testAlternateCreationMethod
	self assert: ((Counter withValue: 19) increment ; count) = 20! !

!CounterTest methodsFor: 'tests' stamp: 'AllexOliveira 5/2/2018 18:16'!
testCounterIsSetAndRead
	| c |
	c := Counter new.
	c count: 7.
	self assert: c count = 7

	
! !

!CounterTest methodsFor: 'tests' stamp: 'AllexOliveira 5/2/2018 18:40'!
testDecrement
	| c |
	c := Counter new.
	c count: 0.
	c decrement ; decrement.
	self assert: c count = -2

	
! !

!CounterTest methodsFor: 'tests' stamp: 'AllexOliveira 5/2/2018 18:38'!
testIncrement
	| c |
	c := Counter new.
	c count: 0.
	c increment ; increment.
	self assert: c count = 2

	
! !

!CounterTest methodsFor: 'tests' stamp: 'AllexOliveira 5/2/2018 18:53'!
testValueAtCreationTimeIsZero
self assert: Counter new count = 0! !

Object subclass: #Counter
	instanceVariableNames: 'count'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MyCounter'!

!Counter commentStamp: 'AllexOliveira 5/2/2018 17:11' prior: 0!
I`m simple counter. 

My API is
- increment decrement 
- count

| c |
c := Counter new.
c increment; increment.
c count = 2!

!Counter class methodsFor: 'instance creation' stamp: 'AllexOliveira 5/2/2018 19:18'!
withValue: aNumber
	| c |
	c := self new.
	c count: aNumber.
	^ c
! !

!Counter methodsFor: 'accessing' stamp: 'AllexOliveira 5/2/2018 17:25'!
count
	^ count! !

!Counter methodsFor: 'accessing' stamp: 'AllexOliveira 5/2/2018 17:55'!
count: aNumber
	count := aNumber! !

!Counter methodsFor: 'operation' stamp: 'AllexOliveira 5/2/2018 18:41'!
decrement
	self count: self count - 1! !

!Counter methodsFor: 'operation' stamp: 'AllexOliveira 5/2/2018 18:40'!
increment
	self count: self count + 1! !

!Counter methodsFor: 'initialization' stamp: 'AllexOliveira 5/2/2018 18:56'!
initialize
	super initialize.
	count := 0 ! !

!Counter methodsFor: 'printing' stamp: 'AllexOliveira 5/2/2018 18:49'!
printOn: aStream
super printOn: aStream.
aStream nextPutAll: ' with value: ', self count printString.
aStream cr.! !
